; Version 1.1

%include ".\equates.inc"

GLOBAL PB_Execute

Extern hInput
Extern hOutput
Extern bWritten
Extern bRead
Extern lpszBuffer
Extern ConsoleTitle
Extern lpszText

Extern PB_StringBase
Extern _CloseHandle@4
Extern _CreatePipe@16
Extern _CreateProcessA@40
Extern _DuplicateHandle@28
Extern _GetConsoleTitleA@8
Extern _GetCurrentProcess@0
Extern _GetExitCodeProcess@8
Extern _GetStartupInfoA@4
Extern _ReadFile@20
Extern _SetConsoleTitleA@4
Extern _WriteFile@20

%include ".\scmacro.mac"

SEGMENT .text USE32 CLASS=CODE

PB_Execute:
    mov [pApplicationName], eax
    mov eax, [esp+4]
    mov [lpCommandLine], eax
    mov dl, [eax]
    mov eax, [pApplicationName]
    mov dh, [eax]
    mov dword [success], 0
    or dl, dh
    jz near .end2
    mov eax, [esp+8]
    mov [lpszText], eax
    mov dword [SECURITY_ATTRIBUTES.nLength], 12
    mov dword [SECURITY_ATTRIBUTES.lpSecurityDescriptor], 0
    mov dword [SECURITY_ATTRIBUTES.bInheritHandle], 1
    sc CreatePipe,hReadPipeIn,hWritePipeIn,SECURITY_ATTRIBUTES,0
    sc CreatePipe,hReadPipeOut,hWritePipeOut,SECURITY_ATTRIBUTES,0
    sc GetCurrentProcess
    sc DuplicateHandle,eax,[hWritePipeIn],eax,hWritePipeInDup,0,0,DUPLICATE_SAME_ACCESS
    sc CloseHandle,[hWritePipeIn]
    mov dword eax, lpStartupInfo.hStdInput
    mov [hInput], eax
    mov dword eax, lpStartupInfo.hStdOutput
    mov [hOutput], eax
    mov dword eax, lpStartupInfo.hStdError
    mov [hError], eax
    sc GetStartupInfoA,lpStartupInfo
    cmp dword [lpStartupInfo.cb], 68
    je .cbnor
    sub dword [hInput], 3
    sub dword [hOutput], 3
    sub dword [hError], 3
  .cbnor:
    mov dword [lpStartupInfo.dwFlags], STARTF_USESTDHANDLES;
    mov eax, [hReadPipeIn]
    mov edx, [hInput]
    mov [edx], eax
    mov edx, [hOutput]
    mov eax, [hWritePipeOut]
    mov [edx], eax
    mov edx, [hError]
    mov [edx], eax
    sc GetConsoleTitleA,[ConsoleTitle],TitleSize;
    mov eax, [esp+16]
    or eax, -3 ; 2 flag
    cmp eax, -1
    jne .check
    mov eax, [lpStartupInfo.dwFlags]
    or eax, STARTF_USESHOWWINDOW
    mov [lpStartupInfo.dwFlags], eax
    mov dword [lpStartupInfo.wShowWindow], SW_HIDE
  .check:
    mov eax, [lpCommandLine]
    cmp byte [eax], " "
    je .launch
    cmp byte [eax], 0
    je .launch
    mov edx, [lpszBuffer]
    mov byte [edx], " "
    inc edx
    push ecx
  .copy1:
    mov byte cl, [eax]
    inc eax
    mov byte [edx], cl
    inc edx
    test cl, cl
    jnz .copy1
    pop ecx
    mov eax, [lpszBuffer]
    mov dword [lpCommandLine], eax
  .launch:
    sc CreateProcessA,[pApplicationName],[lpCommandLine],0,0,1,0,0,0,lpStartupInfo,lpProcessInformation
    mov [success], eax
    sc CloseHandle,[hReadPipeIn]
    sc CloseHandle,[hWritePipeOut]
    cmp dword [success], 0
    jne .launched
    sc CloseHandle,[hWritePipeInDup]
    sc CloseHandle,[hReadPipeOut]
    jmp .end2
  .launched:
    mov eax, [lpszText]
    cmp byte [eax], 0
    je .nostd
    mov edx, eax
  .lop:
    inc eax
    cmp byte [eax], 0
    jne .lop
    sub eax, edx
    sc WriteFile,[hWritePipeInDup],edx,eax,bWritten,0
  .nostd:
    sc CloseHandle,[hWritePipeInDup]
    mov eax, [esp+16]
    or eax, -5 ; 4 flag
    cmp eax, -1
    jne near .seguir
    mov eax, [esp+12]
    mov [lpszText], eax
  .read:
    mov eax, [lpszBuffer]
    mov dword edx, BufferSize
    shr edx, 2
  .reset:
    mov dword [eax], 0
    add eax, 4
    dec edx
    jnz .reset
    sc ReadFile,[hReadPipeOut],[lpszBuffer],BufferSize-1,bRead,0
    test eax, eax
    jz .seguir
    cmp dword [bRead], 0
    je .seguir
    mov eax, [lpszBuffer]
    mov edx, [lpszText]
    push ecx
  .copy2:
    mov byte cl, [eax]
    inc eax
    mov byte [edx], cl
    inc edx
    test cl, cl
    jnz .copy2
    pop ecx
    mov [lpszText], edx
    jmp .read
  .seguir:
    sc CloseHandle,[hReadPipeOut]
    mov eax, [esp+16]
    or eax, -2 ; 1 flag
    cmp eax, -1
    jne .end
  .takecod:
    sc GetExitCodeProcess,[lpProcessInformation.hProcess],lpExitCode
    test eax, eax
    jz .takecod
    cmp dword [lpExitCode], STILL_ACTIVE
    je .takecod
  .end:
    sc CloseHandle,[lpProcessInformation.hProcess]
    sc SetConsoleTitleA,[ConsoleTitle]
  .end2:
    mov dword eax, [success]
    ret 16

[section .bss]

hError resd 1

success resd 1

pApplicationName: resd 1
lpCommandLine: resd 1

hReadPipeIn resd 1
hReadPipeOut resd 1
hWritePipeIn resd 1
hWritePipeOut resd 1
hWritePipeInDup resd 1

lpStartupInfo:
  .cb: resd 1
  .lpReserved: resd 1
  .lpDesktop: resd 1
  .lpTitle: resd 1
  .dwX: resd 1
  .dwY: resd 1
  .dwXSize: resd 1
  .dwYSize: resd 1
  .dwXCountChars: resd 1
  .dwYCountChars: resd 1
  .dwFillAttribute:  resd 1
  .dwFlags: resd 1
  .wShowWindow: resw 1
  .cbReserved2: resw 1
  .lpReserved2: resd 1
  .hStdInput: resd 1
  .hStdOutput: resd 1
  .hStdError: resd 1

lpProcessInformation:
  .hProcess: resd 1
  .hThread: resd 1
  .dwProcessId: resd 1
  .dwThreadId: resd 1

lpExitCode: resd 1

SECURITY_ATTRIBUTES:
  .nLength resd 1
  .lpSecurityDescriptor resd 1
  .bInheritHandle resd 1
